#include <stdio.h>
#include <stdlib.h>
#include <sndfile.h>
#include "libresample.h"
#include <math.h>
#include "BITMAP.H"
#define BLACK_CUT_OFF        1 /* Black cut-off percentile for normalization */
#define WHITE_CUT_OFF        2 /* White cut-off percentile for normalization */
#define 	NOAA_CARRIER	2400

void filter(int order,float b[],int bCount,float a[], int aCount, float *signal, int signalCount,float *zi,float *result){
	long int n,k;
	float tmpM,tmpN;
	for(n=order+1;n<signalCount;n++){
		tmpM=0;
		tmpN=0;
		for(k=0;k<bCount;k++){
			tmpM=tmpM+b[k]*signal[n-k];
		}
		for(k=1;k<aCount;k++){
			tmpN=tmpN+a[k]*result[n-k];
		}
		result[n]=a[0]*tmpM-tmpN;

	}
	
}
void filter_reverse(int order,float b[],int bCount,float a[], int aCount, float *signal, int signalCount,float *zi,float *result){
	long int n,k;
	float tmpM,tmpN;
	for(n=signalCount-order-1;n>=0;n--){
		tmpM=0;tmpN=0;
		for(k=bCount-1;k>=0;k--)tmpM=tmpM+b[bCount-k]*signal[n+k];
		for(k=aCount-1;k>=1;k--)tmpN=tmpN+a[aCount-k]*result[n+k];
		result[n]=a[0]*tmpM-tmpN;
	}
	

}
void normalize(unsigned char *img,int size){
    int *hist;
    int i=0;
    int tmp=0;
    hist=malloc(256);for(i=0;i<255;hist[i++]=0);
    for(i=0;i<size;i++){
		tmp=img[i];
   		++hist[tmp];
    }
    tmp=0;

	//   Determine black/white cut-off counts 
	int blk_cutoff = (size * BLACK_CUT_OFF) / 100;
	int wht_cutoff = (size * WHITE_CUT_OFF) / 100;

    // Find black cut-off intensity value 
	int pixel_cnt = 0;
	int black_val,white_val;
	for( black_val = 0; black_val < 256; black_val++ ){
		pixel_cnt += hist[ black_val ];
		if( pixel_cnt > blk_cutoff )
	  		break;
  	}

  	// Find white cut-off intensity value //
  	pixel_cnt = 0;
  	for( white_val = 255; white_val >= 0; white_val-- ){
		pixel_cnt += hist[ white_val ];
		if( pixel_cnt > wht_cutoff )
	  		break;
  	}

	// Rescale pixels in image for full intensity range //
 	int  val_range = white_val - black_val;
	if( (int) val_range <= 0 )  {	printf("ERROR:negative val_range!\n");  }

 	int pixel_val;
	for( pixel_cnt = 0; pixel_cnt < size; pixel_cnt++ ){
		pixel_val = img[ pixel_cnt ];
		pixel_val = ( (pixel_val - black_val) * 255 ) / val_range;
		pixel_val = ( pixel_val < 0 ? 0 : pixel_val );
		pixel_val = ( pixel_val > 255 ? 255 : pixel_val );
		img[ pixel_cnt ] = pixel_val;
  	}
}
void avg(int order,float *signal,int signalCount,float *result){
	int n,n2;

	float tmp;
	for(n=order;n<signalCount-order;n++){
		tmp=0;
		for(n2=-(int)order/2;n2<(int)order/2+1;tmp+=signal[n+n2++]);
		result[n]=tmp/order;
	}
}


// Findet das in dem bereich von img[pos bis pos+searchmax] ähnlichste vorkommen //
int find_next_pattern(unsigned char* pattern,float *img,int pos, int searchmax, int size){
	// AUTOKORRELATION //
	float r=0,max=0;
	int i,i2,maxpos=0;
	int limit=pos+searchmax;
	if (limit>size) limit=size;
	for(i=pos;i<limit;i++){
		r=0;
		for(i2=0;i2<39;i2++){
			if(i2+i<size) r+=img[i+i2]*pattern[i2]; else return maxpos;
		}
		if (r>max){
			max=r;
			maxpos=i;	
		}
		
	}	
	return maxpos;
	
}

int main (int argc, char *argv[]){
	printf("Version 0.1\n");
	char *wavefile,*imagefile;
	int i,Fs=11025,framesRead,srclen;
	float *buffer,*buffer_resampled;
	int LINELENGTH=2080;
	SNDFILE *srcfile;
    SF_INFO srcinfo;
    void *handle;
    float ratio;
    unsigned char *bytewerte,*bytewerte_turned;
 	int bytewertelen;
 	int tmp;
 	int lastFlag=1,inUsed=0,out;
    unsigned char *syncA=malloc(39);
    for(i=0;i<28;i+=4){
    	syncA[i]=244;
    	syncA[i+1]=244;
    	syncA[i+2]=11;
    	syncA[i+3]=11;
    }
    for(i=28;i<39;syncA[i++]=11);
    if(argc<2) {
	printf("usage: apt -i <wavefile> -o <rawimgfile>\n");
	return 1;
    }
    for(i=1;i<argc;i+=2){
     	if(argv[i][1]=='s')Fs=atoi(argv[i+1]);	
    	if(argv[i][1]=='i')wavefile=argv[i+1];
    	if(argv[i][1]=='o')imagefile=argv[i+1];
    	if(argv[i][1]=='l')LINELENGTH=atoi(argv[i+1]);
    }
   
// Butterworth Filter Koeffizienten //

    memset(&srcinfo, 0, sizeof(srcinfo));
    srcfile = sf_open(wavefile, SFM_READ, &srcinfo);
    if (!srcfile) {      fprintf(stderr, "%s", sf_strerror(NULL));      exit(-1);   }
	
	// Allocate Memory for the complete wave file
	srclen = srcinfo.frames;	
	srclen = (int)srcinfo.frames;	
    buffer = (float *)malloc(srclen * sizeof(float));
    float *buffer2 = (float *)malloc(srclen * sizeof(float));
    buffer_resampled=(float *)malloc(srclen*sizeof(float));
	for(i=0;i<srclen;buffer_resampled[i++]=0);
    
    printf("Frames: %d\n",(int)srclen);
    printf("reading frames...\n");
    framesRead=sf_readf_float(srcfile, buffer,srclen);
	sf_close(srcfile);
	printf("all frames have been read\n");

	for(i=0;i<framesRead;i++){
		buffer_resampled[i]=sqrt(buffer[i]*buffer[i]+buffer[i+1]*buffer[i+1]);
	}

	// Auf 2080 Pixel Bild anpassen (Resampling) //
	// 4160/11025
	ratio=0.377324263;
	printf("resampling...\n");
	handle = resample_open(1 , ratio, ratio);
 	inUsed=0;lastFlag=0;
 	out = resample_process(handle, ratio , buffer_resampled, framesRead,lastFlag, &inUsed, buffer, (int)round(framesRead*ratio+1000));
 	resample_close(handle);
 	printf("resampling done!\n");
 	// Auf 0..255 skalieren

 
 	for(i=0;i<out;buffer[i++]*=255);

	bytewertelen=(int)out+LINELENGTH-((out+LINELENGTH)%LINELENGTH); 
  	int padding=LINELENGTH-(out+LINELENGTH)%LINELENGTH;
	bytewerte=(unsigned char*)malloc(bytewertelen);
	for(i=0;i<bytewertelen;bytewerte[i++]=0);
	bytewerte_turned=(unsigned char*)malloc(3*bytewertelen/2);	

	int off=0;

/*	int cnt=0,idx=50;
	int cnt2=0;
	int oldoff=0;
	int off2;
	int out2=0;
	float *linebuf=malloc(3*LINELENGTH);
	for(i=0;i<3*LINELENGTH;linebuf[i++]=0);
	float *linebuf2=malloc(3*LINELENGTH);
	for(i=0;i<3*LINELENGTH;linebuf2[i++]=0);
	double rat=LINELENGTH;
	while(idx<out-2080){
    	off=find_next_sync(syncA,buffer_resampled,idx-50,LINELENGTH,out);
		off2=find_next_sync(syncA,buffer_resampled,off+50,LINELENGTH,out);
	    printf("SYNC%d at %d (%d->",cnt2++,off,off2-off);
		if(off2-off!=LINELENGTH){
			printf(".");
			handle = resample_open(0 , rat/(off2-off),rat/(off2-off));
		 	inUsed=0;lastFlag=0;
	 		for(i=0;i<off2-off;linebuf[i]=buffer_resampled[idx+off+i++]);
	 		out2 = resample_process(handle, rat/(off2-off) , linebuf, off2-off, lastFlag, &inUsed, linebuf2, 3*LINELENGTH+1000);
		 	printf("%d)\n",out2);
		 	resample_close(handle);
	 
	 		for(i=0;i<LINELENGTH;i++){
				tmp=round(linebuf2[i]);
				if(tmp>255) tmp=255;if(tmp<0) tmp=0;
			   	bytewerte[cnt++]=tmp;    	
		    }
	    } else {
	    
//    	if(off>idx+2080)off=idx+2080;
	    	for(i=off;i<off+LINELENGTH;i++){
				tmp=round(buffer_resampled[i]);
				if(tmp>255) tmp=255;if(tmp<0) tmp=0;
			   	bytewerte[cnt++]=tmp;    	
		    }
		}
	    idx=off2;
	}
*/
	// Ränder an den Rand bringen
	off=find_next_pattern(syncA,buffer,0,out,out);
	off=off+47;
	off=off%LINELENGTH;

	// in das BITMAPFeld kopieren


    for(i=off;i<out-(LINELENGTH-off);i++){
		tmp=round(buffer[i]);
		if(tmp>255) tmp=255;if(tmp<0) tmp=0;
	   	bytewerte[i-off]=tmp;    	
    }

	// BILD verbessern //   
	normalize(bytewerte,out);

    unsigned char* bild1=malloc(bytewertelen/2);
    unsigned char* bild2=malloc(bytewertelen/2);
    unsigned char* bild3=malloc(3*bytewertelen/2);
    int bild1cnt=0,bild2cnt=0;
    int i2=0;
    for(i=0;i<bytewertelen;i+=LINELENGTH){
    	for(i2=0;i2<1040;bild1[bild1cnt++]=bytewerte[i+i2++]);
    	for(i2=0;i2<1040;bild2[bild2cnt++]=bytewerte[i+1040+i2++]);	
    }
    
    // Versuch einer Farbdarstellung aus den beiden Kanälen //
    int vidx=0;
    int foundwater=0;
    for(i=0;i<bytewertelen/2;i++){
 	    	if(bild1[i]<20 && bild2[i]<120) foundwater=1;
 	    	
 	    	
		    vidx=round(255*(bild2[i]-bild1[i])/(0.0001+(bild2[i]+bild1[i])));	
		    if(foundwater==1){
		    	bild3[3*i]=180;
		    	vidx=bild2[i];
		    } else {
		    	bild3[3*i]=bild1[i];
		    }
			if(vidx>=bild2[i]) bild3[3*i+1]=vidx; else bild3[3*i+1]=bild2[i];
		    
		    vidx=round((bild1[i]+2*bild2[i])/2);
		    if(vidx>255)vidx=255;
	    	bild3[3*i+2]=vidx;
	    	foundwater=0;
     }
    
    // BILD umdrehen //
     for(i=0;i<bytewertelen;i=i+LINELENGTH){
    	for(i2=0;i2<LINELENGTH;i2++){
    		bytewerte_turned[i+i2]=bytewerte[bytewertelen-LINELENGTH-i+i2];
    	}
    }
    // BITMAP Datei schreiben //
	BITMAPINFO bm;
	bm.bmiHeader.biSize=40;
	bm.bmiHeader.biWidth=LINELENGTH;
	bm.bmiHeader.biHeight=(int)round(bytewertelen/(LINELENGTH));
	bm.bmiHeader.biPlanes=1;
	bm.bmiHeader.biBitCount=8;
	bm.bmiHeader.biCompression=BI_RGB;
	bm.bmiHeader.biSizeImage=0;
	bm.bmiHeader.biXPelsPerMeter=0;
	bm.bmiHeader.biYPelsPerMeter=0;
	bm.bmiHeader.biClrUsed=256;
	bm.bmiHeader.biClrImportant=0;
	for(i=0;i<255;i++){
		bm.bmiColors[i].rgbBlue=i;
		bm.bmiColors[i].rgbRed=i;
		bm.bmiColors[i].rgbGreen=i;
		bm.bmiColors[i].rgbReserved=0;	
	}
	// SAVE RAW IMAGE //
	SaveDIBitmap(imagefile,&bm,bytewerte_turned);    
	
	// SAVE splitted images
	
	bm.bmiHeader.biWidth=LINELENGTH/2;
	bm.bmiHeader.biHeight=(int)round(bytewertelen/2/(LINELENGTH/2));    
    for(i=0;i<bytewertelen/2;i=i+LINELENGTH/2){
    	for(i2=0;i2<LINELENGTH/2;i2++){
    		bytewerte_turned[i+i2]=bild1[bytewertelen/2-LINELENGTH/2-i+i2];
    	}
    }
	SaveDIBitmap("A.bmp",&bm,bytewerte_turned);    
	for(i=0;i<bytewertelen/2;i=i+LINELENGTH/2){
    	for(i2=0;i2<LINELENGTH/2;i2++){
    		bytewerte_turned[i+i2]=bild2[bytewertelen/2-LINELENGTH/2-i+i2];
    	}
    }
	SaveDIBitmap("B.bmp",&bm,bild2);    
/*	bm.bmiHeader.biBitCount=24;
	bm.bmiHeader.biClrUsed=0;
	for(i=0;i<3*bytewertelen/2;i=i+3*LINELENGTH/2){
    	for(i2=0;i2<3*LINELENGTH/2;i2++){
    		bytewerte_turned[i+i2]=bild2[3*bytewertelen/2-3*LINELENGTH/2-i+i2];
    	}
    }
   	SaveDIBitmap("MIX.bmp",&bm,bild3);    
  */  
    
    for(i=0;i<bytewertelen;i=i+LINELENGTH)
    {
    	for(i2=0;i2<LINELENGTH;i2++){
    		bytewerte_turned[i+i2]=bytewerte[bytewertelen-LINELENGTH-i+i2];
    	}
    }

    

    free(bytewerte);
    free(buffer);
    free(buffer_resampled);
    return 0;
}

static int            write_word(FILE *fp, unsigned short w);
static int            write_dword(FILE *fp, unsigned int dw);
static int            write_long(FILE *fp, int l);


int                                /* O - 0 = success, -1 = failure */
SaveDIBitmap(const char *filename, /* I - File to load */
             BITMAPINFO *info,     /* I - Bitmap information */
	     unsigned char    *bits)     /* I - Bitmap data */
    {
    FILE *fp;                      /* Open file pointer */
    int  size,                     /* Size of file */
         infosize,                 /* Size of bitmap info */
         bitsize;                  /* Size of bitmap pixels */


    /* Try opening the file; use "wb" mode to write this *binary* file. */
    if ((fp = fopen(filename, "wb")) == NULL)
        return (-1);

    /* Figure out the bitmap size */
    if (info->bmiHeader.biSizeImage == 0)
	bitsize = (info->bmiHeader.biWidth *
        	   info->bmiHeader.biBitCount + 7) / 8 *
		  abs(info->bmiHeader.biHeight);
    else
	bitsize = info->bmiHeader.biSizeImage;

    /* Figure out the header size */
    infosize = sizeof(BITMAPINFOHEADER);
    switch (info->bmiHeader.biCompression)
	{
	case BI_BITFIELDS :
            infosize += 12; /* Add 3 RGB doubleword masks */
            if (info->bmiHeader.biClrUsed == 0)
	      break;
	case BI_RGB :
            if (info->bmiHeader.biBitCount > 8 &&
        	info->bmiHeader.biClrUsed == 0)
	      break;
	case BI_RLE8 :
	case BI_RLE4 :
            if (info->bmiHeader.biClrUsed == 0)
              infosize += (1 << info->bmiHeader.biBitCount) * 4;
	    else
              infosize += info->bmiHeader.biClrUsed * 4;
	    break;
	}

//    size = sizeof(BITMAPFILEHEADER) + infosize + bitsize;
    size=14+infosize+bitsize;

    /* Write the file header, bitmap information, and bitmap pixel data... */
    write_word(fp, BF_TYPE);        /* bfType */
    write_dword(fp, size);          /* bfSize */
    write_word(fp, 0);              /* bfReserved1 */
    write_word(fp, 0);              /* bfReserved2 */
    write_dword(fp, 14 + infosize); /* bfOffBits */

    write_dword(fp, info->bmiHeader.biSize);
    write_long(fp, info->bmiHeader.biWidth);
    write_long(fp, info->bmiHeader.biHeight);
    write_word(fp, info->bmiHeader.biPlanes);
    write_word(fp, info->bmiHeader.biBitCount);
    write_dword(fp, info->bmiHeader.biCompression);
    write_dword(fp, info->bmiHeader.biSizeImage);
    write_long(fp, info->bmiHeader.biXPelsPerMeter);
    write_long(fp, info->bmiHeader.biYPelsPerMeter);
    write_dword(fp, info->bmiHeader.biClrUsed);
    write_dword(fp, info->bmiHeader.biClrImportant);

    if (infosize > 40)
	if (fwrite(info->bmiColors, infosize - 40, 1, fp) < 1)
            {
            /* Couldn't write the bitmap header - return... */
            fclose(fp);
            return (-1);
            }

    if (fwrite(bits, 1, bitsize, fp) < bitsize)
        {
        /* Couldn't write the bitmap - return... */
        fclose(fp);
        return (-1);
        }

    /* OK, everything went fine - return... */
    fclose(fp);
    return (0);
    }


/*
 * 'write_word()' - Write a 16-bit unsigned integer.
 */

static int                     /* O - 0 on success, -1 on error */
write_word(FILE           *fp, /* I - File to write to */
           unsigned short w)   /* I - Integer to write */
    {
    putc(w, fp);
    return (putc(w >> 8, fp));
    }


/*
 * 'write_dword()' - Write a 32-bit unsigned integer.
 */

static int                    /* O - 0 on success, -1 on error */
write_dword(FILE         *fp, /* I - File to write to */
            unsigned int dw)  /* I - Integer to write */
    {
    putc(dw, fp);
    putc(dw >> 8, fp);
    putc(dw >> 16, fp);
    return (putc(dw >> 24, fp));
    }


/*
 * 'write_long()' - Write a 32-bit signed integer.
 */

static int           /* O - 0 on success, -1 on error */
write_long(FILE *fp, /* I - File to write to */
           int  l)   /* I - Integer to write */
    {
    putc(l, fp);
    putc(l >> 8, fp);
    putc(l >> 16, fp);
    return (putc(l >> 24, fp));
    }
